<template>
	<div>
		<div class="main-header lightestazure-color" :class="header_class">
			<div class="main-column">
				<div class="flex space row-padding v-top">
					<div class="flex columns-4">
						<div class="glitch-wrapper" v-on:click="switchPanel(0)">
							<h3 class="glitch hustle" data-text="VAIRUS">VAIRUS</h3>
						</div>
					</div>
					
					<div class="panel-index columns-4 uppercase medium-font darkazure-color">
						<ul class="flex bold">
							<li class="label" v-bind:class="{ 'lightestazure-color': current_panel == 0 }" v-on:click="switchPanel(0)">{{getLocale('activities')}}</li>
							<li class="label" v-bind:class="{ 'lightestazure-color': current_panel == 1 }" v-on:click="switchPanel(1)">Vairus</li>
							<li class="label" v-if="checkTutorial('network') || network_introduction" v-bind:class="{ 'lightestazure-color': current_panel == 2, pulse : network_introduction && !checkTutorial('network') }" v-on:click="switchPanel(2)">Network</li>
							<li class="label" v-if="checkTutorial('analyzer')" v-bind:class="{ 'lightestazure-color': current_panel == 3 }" v-on:click="switchPanel(3)">Analyzer</li>
					
							<li class="label" v-on:click="switchPanel(4)" >
								<svg xmlns="http://www.w3.org/2000/svg" height="24px" viewBox="0 0 24 24" width="24px">
									<g>
										<path d="M0,0h24v24H0V0z" fill="none"/>
										<path :fill="current_panel == 4 ? '#B3EDFF' : '#07779F'" d="M19.14,12.94c0.04-0.3,0.06-0.61,0.06-0.94c0-0.32-0.02-0.64-0.07-0.94l2.03-1.58c0.18-0.14,0.23-0.41,0.12-0.61 l-1.92-3.32c-0.12-0.22-0.37-0.29-0.59-0.22l-2.39,0.96c-0.5-0.38-1.03-0.7-1.62-0.94L14.4,2.81c-0.04-0.24-0.24-0.41-0.48-0.41 h-3.84c-0.24,0-0.43,0.17-0.47,0.41L9.25,5.35C8.66,5.59,8.12,5.92,7.63,6.29L5.24,5.33c-0.22-0.08-0.47,0-0.59,0.22L2.74,8.87 C2.62,9.08,2.66,9.34,2.86,9.48l2.03,1.58C4.84,11.36,4.8,11.69,4.8,12s0.02,0.64,0.07,0.94l-2.03,1.58 c-0.18,0.14-0.23,0.41-0.12,0.61l1.92,3.32c0.12,0.22,0.37,0.29,0.59,0.22l2.39-0.96c0.5,0.38,1.03,0.7,1.62,0.94l0.36,2.54 c0.05,0.24,0.24,0.41,0.48,0.41h3.84c0.24,0,0.44-0.17,0.47-0.41l0.36-2.54c0.59-0.24,1.13-0.56,1.62-0.94l2.39,0.96 c0.22,0.08,0.47,0,0.59-0.22l1.92-3.32c0.12-0.22,0.07-0.47-0.12-0.61L19.14,12.94z M12,15.6c-1.98,0-3.6-1.62-3.6-3.6 s1.62-3.6,3.6-3.6s3.6,1.62,3.6,3.6S13.98,15.6,12,15.6z"/>
									</g>
								</svg>
							</li>
						</ul>
					</div>
					
					<div class="columns-4">
						<div class="name flex h-right v-center align-right">
							<div>Hacker <span class="bold">{{username}}</span></div>
							<div class="bag-icon" v-on:click="bag = true;">
								<svg version="1.1" xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 34 28">
									<path  fill="#B3EDFF" d="M10 25.5l6-3v-4.906l-6 2.562v5.344zM9 18.406l6.312-2.703-6.312-2.703-6.312 2.703zM26 25.5l6-3v-4.906l-6 2.562v5.344zM25 18.406l6.312-2.703-6.312-2.703-6.312 2.703zM18 13.828l6-2.578v-4.156l-6 2.562v4.172zM17 7.906l6.891-2.953-6.891-2.953-6.891 2.953zM34 16v6.5c0 0.75-0.422 1.453-1.109 1.781l-7 3.5c-0.281 0.156-0.578 0.219-0.891 0.219s-0.609-0.063-0.891-0.219l-7-3.5c-0.047-0.016-0.078-0.031-0.109-0.063-0.031 0.031-0.063 0.047-0.109 0.063l-7 3.5c-0.281 0.156-0.578 0.219-0.891 0.219s-0.609-0.063-0.891-0.219l-7-3.5c-0.688-0.328-1.109-1.031-1.109-1.781v-6.5c0-0.797 0.484-1.516 1.219-1.844l6.781-2.906v-6.25c0-0.797 0.484-1.516 1.219-1.844l7-3c0.25-0.109 0.516-0.156 0.781-0.156s0.531 0.047 0.781 0.156l7 3c0.734 0.328 1.219 1.047 1.219 1.844v6.25l6.781 2.906c0.75 0.328 1.219 1.047 1.219 1.844z"></path>
								</svg>
							</div>
						</div>
						
						<div class="resources flex h-right v-center">
							<div class="bytes align-center flex v-center h-right">
								<div class="avaiable hustle">
									<number-changer
										:number="bytes"
									></number-changer>
								</div>
								<bytes-icon class="icon"/>
							</div>
							
						</div>
					</div>
				</div>
			</div>
		</div>
				
		<div class="panel-container">
			<div class="panel" v-show="current_panel == 0">
				<div class="main-column">
					<div class="row-padding" v-if="checkTutorial('introduction')">
						<dailies/>
					</div>
					<div class="row-padding" v-else>
						<introduction/>
					</div>
					
					<div class="row-padding" v-show="active_nodes.length > 0">
						<network-recap @gotonode="goToNode"/>
					</div>
					
					<div class="row-padding" v-show="checkTutorial('matrix')">
						<matrix-recap/>
					</div>
				</div>
			</div>
			
			<div class="panel" style="overflow-x: unset;" :class="{'azure-gradient' : !codex}" v-show="current_panel == 1" v-on:click.self="codex = false">
				<div class="main-column">
					
					<keep-alive>
						<vairus-list 
							class="row-padding"
							v-show="!codex"
							ref="main_list"
							:list="vairus_list" 
							:boxes="boxes" 
							:main="true" 
							:stats="false"
							:tutorial="tutorial"
							show_footer="true" 
							@addtobox="addToBox" 
							@transfertobox="transferToBox" 
							@clicked="showDetail"
							@destroymass="destroyMass" 
							@editboxlabel="editBoxLabel" 
							@codex="codex = true" 
						/>
					</keep-alive>
					
					<keep-alive>
						<codex
							v-show="codex"
							:list="vairus_list" 
							@close="codex = false"
						/>
					</keep-alive>
				</div>
				
				<transition name="fade">
					<div class="vairus-details" v-if="detailed_vairus != null" >
						<div class="backdrop" v-on:click="closeDetail"></div>
						<vairus-details 
							ref="details"
							:vairus="vairus_list[detailed_index]" 
							@edit_label="editLabel" 
							@next_detail="nextDetail" 
							@destroy="destroyVairus" 
							@close="closeDetail"
						/>
					</div>
				</transition>
			</div>
			
			<div class="panel pink-gradient" v-show="current_panel == 2">
				<keep-alive>
					<nodes ref="nodes_panel"/>
				</keep-alive>
			</div>
			
			<div class="panel" v-show="current_panel == 3">
				<analyzer ref="analyzer_panel" />
			</div>
			
			<div class="panel" v-show="current_panel == 4">
				<profile-options
					v-if="current_panel == 4"
				/>
			</div>
		</div>
		
		<footer class="small-font">
			<div class="main-column flex space">
				<div class="feedback" v-on:click="switchPanel(4)">{{getLocale('send_feedback_footer')}}</div>
				
				<div class="links">
					<a v-for="(link, text) in links" :href="link" target="_blank">{{text}}</a>
				</div>
			</div>
		</footer>
		
		
		<transition name="fade">
			<div class="bag-modal lightestazure-color" v-if="bag">
				<div class="backdrop" v-on:click.self="bag = false"></div>
				<div class="inner azure-gradient">
					<div class="header flex space">
						<div class="hustle medium">{{getLocale('items')}}</div>
						
						<close-icon class="close-button" color="#B3EDFF	" @clicked="bag = false"/>
					</div>
					
					<div class="contents">
						<div class="row bytes">
							<div class="medium-font uppercase">Bytes</div>
							
							<div class="item">
								<div class="wrapper">
									<bytes-icon class="icon"/>
									<div class="avaiable">
										<number-changer
											:number="bytes"
										></number-changer>
									</div>
								</div>
							</div>
						</div>
						<div class="row shards ">
							<div class="medium-font uppercase">{{getLocale('shards')}}</div>
							
							<div class="flex">
								<div class="item" v-for="(shard, type) in shards">
									<div class="wrapper">
										<div class="icon">
											<img v-bind:src="getImage('shards/'+type+'.png')">
										</div>
										
										<div class="avaiable">
											<number-changer
												:number="shard"
											></number-changer>
										</div>
									</div>
								</div>
							</div>
						</div>
						<div class="row keys">
							<div class="medium-font uppercase">{{getLocale('keys')}}</div>
							
							<div class="flex">
								<div class="item" v-for="(key, index) in keys">
									<div class="wrapper">
										<div class="icon">
											<img class="key" v-bind:src="getImage('key'+(index+1)+'.png')">
										</div>
										
										<div class="avaiable">
											<number-changer
												:number="key"
											></number-changer>
										</div>
									</div>
								</div>
							</div>
						</div>
						<div class="row bytes">
							<div class="medium-font uppercase">Chips</div>
							
							<div class="item">
								<div class="wrapper">
									<div class="icon">
										<img class="key" v-bind:src="getImage('chips.png')">
									</div>
									
									<div class="avaiable">
										<number-changer
											:number="chips"
										></number-changer>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</transition>
		
		<transition name="fade">
			<div class="error-modal" v-if="error != null" v-on:click="closeError">
				<div class="error">
					<div class="title medium-font uppercase">Errore</div>
					<div class="text">{{error}}</div>
				</div>
			</div>
		</transition>
	
		<transition name="fade">
			<div class="loader" v-if="!mounted">
				<div class="loading">
					<div class="dot"></div>
					<div class="dot"></div>
					<div class="dot"></div>
				</div>
			</div>
		</transition>
		
		<div class="tooltip lightestazure-border lightestazure-color" v-if="tooltipText" :style="tooltipStyle" v-html="tooltipText"></div>
		
		<!-- TUTORIAL -->
		
		<tutorial :tutorial_step="current_tutorial.flag" :color="tutorial_color"/>
	</div>
</template>


<script>
	var browser = browser || chrome;
	
	import { vueEventBus } from '../classes/eventBus.js';
	import { commonMixin } from '../mixins/common.js';
	import { storeGettersMixin } from '../mixins/store_getters.js';
	import NumberChanger from '../components/NumberChanger.vue';
	import Tutorial from '../components/Tutorial.vue';
	import VairusList from '../components/VairusList.vue';
	import Introduction from '../components/Introduction.vue';
	import Dailies from '../components/Dailies.vue';
	import VairusDetails from '../components/VairusDetails.vue';
	import Nodes from '../components/Nodes.vue';
	import Codex from '../components/Codex.vue';
	import Analyzer from '../components/Analyzer.vue';
	import NetworkRecap from '../components/NetworkRecap.vue';
	import MatrixRecap from '../components/MatrixRecap.vue';
	import ProfileOptions from '../components/ProfileOptions.vue';
	import VButton from '../components/VButton.vue';
	import BytesIcon from '../components/BytesIcon.vue';
	import CloseIcon from '../components/CloseIcon.vue';
	
	
	setInterval(function(){
		vueEventBus.$emit('heartbeat', Date.now());
	}, 3000);


	export default {
		data () { 
			return {
				mode : process.env.NODE_ENV,
				mounted : false,
				requesting : false,
				error : null,
				header_class : '',
				order : '',
				current_panel : 0,
				codex : false,
				bag : false
			}
		},
		mounted: function () {
			this.requesting = true;
		
			setTimeout(function(){
				this.mounted = true;
				this.requesting = false;
				
			}.bind(this),500);
			
			setInterval(function(){
				this.$store.commit('refreshCurrentTime');
			}.bind(this),1000);
			
			setInterval(function(){
				this.$store.commit('resetLocks');
			}.bind(this),10000);
			
			vueEventBus.$on('heartbeat', this.checkDayAdvancement);
			
			//Consume the hash and navigate to the corrisponding panel
			if(window.location.hash != ''){
				switch(window.location.hash){
					case '#vairus':
						this.current_panel = 1;
					break;
					case '#network':
						this.current_panel = 2;
					break;
					case '#analyzer':
						this.current_panel = 3;
					break;
				}
				history.replaceState(null, null, ' ');
			}
		},
		created: function () {
			browser.runtime.sendMessage({ type : 'request_userdata' });
			
			//Keybindings
			document.addEventListener('keydown',function(e) {
				if(this.$refs.details && !this.$refs.details.edit_mode){
					switch(e.which) {
						case 37: // left
							if(this.detailed_vairus != null){
								this.nextDetail(this.detailed_vairus, 'prev');
								e.preventDefault();
							}
						break;
						case 39: // right
							if(this.detailed_vairus != null){
								this.nextDetail(this.detailed_vairus, 'next');
								e.preventDefault();
							}
						break;
						case 27: // esc
							if(this.detailed_vairus != null){
								this.closeDetail();
								e.preventDefault();
							}
						break;
					}
				}
			}.bind(this));

			//Background message handler
			browser.runtime.onMessage.addListener( function(request) {
				switch(request.type){
					case 'sync_vairus':
						let message = request.data;
						switch(message.type){
							case 'all_vairus':
								this.$store.commit('setVairusList', message.data);
							break;
							case 'add_vairus':
								this.$store.commit('addVairus', message.data);
							break;
							case 'update_vairus_exhaustion':
								this.$store.commit('updateVairusExhaustion', message.data);
							break;
							case 'update_vairus_level':
								this.$store.commit('updateVairusLevel', message.data);
							break;
							break;
							case 'update_vairus_attributes':
								this.$store.commit('updateVairusAttributes', message.data);
								this.$refs.details.setAllPhantomsOff();
							break;
							case 'update_vairus_label':
								this.$store.commit('updateVairusLabel', message.data);
							break;
							case 'destroy_vairus':
								this.$store.commit('destroyVairus', message.data.vairus_to_destroy);
							break;
						}
					
						setTimeout(function(){
							vueEventBus.$emit('heartbeat', Date.now());
						});
					break;
					
					case 'sync_data':
						for(var type in request.data){
							if(type == 'boxes'){
								this.$store.commit('setResource', { 
									type : type, 
									value : [{"name":browser.i18n.getMessage('base_box'),"vairus":[]}].concat(request.data.boxes)
								})
							}else{
								this.$store.commit('setResource', { 
									type : type, 
									value : request.data[type]
								})
							}
						}
						
						//Tutorial
						if(!this.checkTutorial('start')){
							this.setTutorial('start', true);
						}
						
						if(!this.checkTutorial('analyzer') && this.checkTutorial('introduction')){
							this.setTutorial('analyzer', true, false, 'red');
						}
						
						setTimeout(function(){
							vueEventBus.$emit('heartbeat', Date.now());
							
						}.bind(this));
					break;
					
					case 'sync_matrixes':
						this.$store.commit('setMatrixRewards', request.data)
					break;
				}
			}.bind(this));
		},
		methods: {
			checkDayAdvancement(){
				let day = new Date().getUTCDate();
				this.$store.dispatch('setCurrentDay');
			},
			switchPanel(panel){
				this.current_panel = panel;
				this.codex = false;
				this.$refs.nodes_panel.vairus_list.active = false;
				
				if(panel == 3){
					setTimeout(function(){
						this.$refs.analyzer_panel.calculateRatio();
					}.bind(this), 1);
					
					setTimeout(function(){
						if(!this.checkTutorial('analyzer_profile')){
							this.setTutorial('analyzer_profile', true, false, 'red');
						}
					}.bind(this), 500);
				}
			},
			goToNode(node_id){
				this.current_panel = 2;
				this.$refs.nodes_panel.back_to_dashboard = true;
				this.$refs.nodes_panel.selectNode(node_id);
			},
			showError(error){
				this.error = error;
			},
			closeError(){
				this.error = null;
			},
			showDetail(unique_id){
				this.$store.commit('setDetailed', unique_id);
			},
			closeDetail(){
				this.$store.commit('setDetailed', null);
			},
			destroyMass(vairus_list){
				if(vairus_list.length > 0) this.destroyVairus(vairus_list);
			},
			destroyVairus(vairus_array){
				browser.runtime.sendMessage({
					type : 'destroy_vairus',
					data : { 
						list : vairus_array,
					}
				});
			},
			nextDetail(unique_id, type){
				let vairus = this.$refs.main_list.nextDetail(unique_id, type);
				this.$store.commit('setDetailed', vairus);
				setTimeout(this.$refs.details.updateExhaustion);
			},
			editLabel(label){
				this.vairus_list[this.detailed_index].label = label;
				browser.runtime.sendMessage({
					type : 'edit_label',
					data : { 
						unique_id : this.vairus_list[this.detailed_index].unique_id,
						label : label
					}
				});
			},
			editBoxLabel(label, index){
				browser.runtime.sendMessage({
					type : 'edit_box_label',
					data : { 
						index : index,
						label : label
					}
				});
			},
			addToBox(index, vairus_id, current_box){
				let push_box = this.boxes[index].vairus;
				let pull_box = this.boxes[current_box].vairus;
				
				//Adding the Vairus to the selected box
				if(push_box.indexOf(vairus_id) === -1) push_box.push(vairus_id);
				
				//If not the first box i remove the Vairus from the list
				if(current_box !== 0){
					let remove_index = pull_box.indexOf(vairus_id);
					pull_box.splice(remove_index, 1);
				}
				
				//Data sync
				let box_to_send = this.boxes.slice();
				box_to_send.shift();
				
				browser.runtime.sendMessage({
					type : 'update_boxes',
					data : box_to_send
				});
			},
			transferToBox(selected, index){
				selected.forEach(function(vairus_id){
					this.boxes.forEach(function(box){
						let remove_index = box.vairus.indexOf(vairus_id);
						if(remove_index !== -1){
							box.vairus.splice(remove_index, 1);
						}
					}.bind(this));
					
					if(this.boxes[index].vairus.indexOf(vairus_id) === -1){
						this.boxes[index].vairus.push(vairus_id);
					} 
				}.bind(this));
				
				//Data sync
				let box_to_send = this.boxes.slice();
				box_to_send.shift();
				
				browser.runtime.sendMessage({
					type : 'update_boxes',
					data : box_to_send
				});
			}
		},
		computed: {
			tooltipText(){
				return this.$store.state.tooltip.text;
			},
			tooltipStyle(){
				return {
					top : this.$store.state.tooltip.top+'px', 
					left : this.$store.state.tooltip.left+'px'
				};
			},
		},
		watch: {
			current_panel: function (panel) {
				switch(panel){
					case 2:
						setTimeout(function(){
							if(!this.checkTutorial('network')){
								this.setTutorial('network', true);
							}
						}.bind(this), 500);
					break;
				}
			}
		},
		mixins: [commonMixin, storeGettersMixin],
		components: {
			NumberChanger,
			Tutorial,
			VButton,
			BytesIcon,
			CloseIcon,
			VairusList,
			Introduction,
			Dailies,
			VairusDetails,
			Nodes,
			Analyzer,
			NetworkRecap,
			Codex,
			MatrixRecap,
			ProfileOptions
		}
	}
</script>


<style lang="scss">
	@import "../styles/variables";
	@import "../styles/styles";

	/* COLORS */

	.mountain-bkg,
	.earth-bkg{
		background-color: #B67341 !important;
	}
	.sky-bkg,
	.air-bkg{
		background-color: #F2F2F2 !important;
	}
	.desert-bkg,
	.fire-bkg{
		background-color: #FFCE4A !important;
	}
	.ocean-bkg,
	.water-bkg{
		background-color: #38A0D2 !important;
	}
	.swamp-bkg,
	.acid-bkg{
		background-color: #E5E323 !important;
	}
	.city-bkg,
	.electric-bkg{
		background-color: #BFD2D2 !important;
	}
	.glacier-bkg,
	.ice-bkg{
		background-color: #48C4D2 !important;
	}
	.forest-bkg,
	.nature-bkg{
		background-color: #7BA41D !important;
	}
	.glitch-bkg{
		background: radial-gradient(#e66465, #9198e5);
	}

	.mountain-border,
	.earth-border{
		border-color: #B67341 !important;
	}
	.sky-border,
	.air-border{
		border-color: #F2F2F2 !important;
	}
	.desert-border,
	.fire-border{
		border-color: #FFCE4A !important;
	}
	.ocean-border,
	.water-border{
		border-color: #38A0D2 !important;
	}
	.swamp-border,
	.acid-border{
		border-color: #E5E323 !important;
	}
	.city-border,
	.electric-border{
		border-color: #BFD2D2 !important;
	}
	.glacier-border,
	.ice-border{
		border-color: #48C4D2 !important;
	}
	.forest-border,
	.nature-border{
		border-color: #7BA41D !important;
	}

	/* DEFAULT */

	#vairus-vue-app{
		overflow-x: hidden;
	}
	
	.label::first-letter {
		text-transform: uppercase;
	}

	/* ERROR */


	.error-modal{
		position: fixed;
		top: 0;
		bottom: 0;
		left: 0;
		right: 0;
		background-color: rgba(0,0,0,0.7);
		z-index: 1;
	}
	.error-modal .error{
		position: absolute;
		left: 50%;
		top: 50%;
		padding: 10px 20px;
		background-color: black;
		border: 1px solid white;
		transform: translate(-50%, -50%);
		text-align: center;
		cursor: pointer;
	}
	.error-modal .error .text{
		margin-top: 10px;
	}


	/* HEADER */

		
	.main-header{
		
		.glitch-wrapper{
			cursor: pointer;
			
			h3{
				padding-right: 20px;
				font-size: 7rem;
				line-height: 1;
				padding-top: 3px;
				text-transform: lowercase;
			}
		}
			
		.panel-index{
			z-index: 1;
			
			ul{
				list-style: none;
				justify-content: center;
				
				li{
					padding: 0 20px;
					cursor: pointer;
					
					&.current{
						font-weight: bold;
						cursor: default;
					}
					
					&.pulse{
						transform: scale(1);
						animation: pulse 1s infinite;
					}
				}
			}
		}
		
		.name{
			.icon{
				width: 24px;
				height: 24px;
				margin-left: 5px;
				cursor: pointer;
			}
		}
		.resources{
			margin-top: 10px;
			
			.bytes{
				.avaiable{
					width: 200px;
					text-align: right;
				}
				
				.icon{
					margin-left: 6px;
				}
			}
		}
		.bag-icon{
			margin-left: 8px;
			cursor: pointer;
		}
		.reload-button{
			width: 32px;
			height: 32px;
			margin-top: 38px;
			margin-right: 25px;
			background-size: contain;
			background-position: center;
			background-repeat: no-repeat;
			cursor: pointer;
			opacity: 1;
			transition: 0.3s opacity;
			
			&.requesting{
				opacity: 0.5;
				pointer-events: none;
				cursor: default;
			}
		}
	}
	
	
	.bag-modal{
		position: fixed;
		top: 0;
		left: 0;
		bottom: 0;
		right: 0;
		z-index: 5;
		
		.backdrop{
			position: absolute;
			top: 0;
			left: 0;
			bottom: 0;
			right: 0;
			background-color: rgba(0, 0, 0, 0.7);
		}
		
		.inner{
			position: absolute;
			top: 50%;
			left: 50%;
			transform: translate(-50%, -50%);
			border-radius: 10px;
			padding: 20px;
			width: 400px;
			
			
			.header{
				margin-bottom: 25px;
			}
			
			.row{
				padding-bottom: 10px;
				margin-bottom: 15px;
				border-bottom: 1px solid $lightestazure;
				
				&:last-child{
					margin-bottom: 0;
					border-bottom: none;
				}
				
				.medium-font{
					margin-bottom: 10px;
				}
				
				.item{
					display: inline-block;
					margin-right: 10px;
					margin-bottom: 5px;
					
					.wrapper{
						display: flex;
						text-align: center;
						align-items: center;
						
						> div:first-child{
							margin-right: 7px;
						}
					}
					img{
						width: 20px;
						height: 20px;
						object-fit: contain;
					}
				}
			}
			
			.shards .flex,
			.keys .flex{
				flex-wrap: wrap;
				
				.item{
					flex: 1 0 21%;
					text-align: left;
				}
			}
		}
	}


	/* PANELS */

	.panel-container{
		margin-bottom: 100px;
		
		.panel{
			overflow-x: hidden;
		}
	}
	

	/* LOADER */


	.loader{
		position: absolute;
		top: 0;
		left: 0;
		bottom: 0;
		right: 0;
		background-color: black;
		z-index: 1;
		
		.loading{
			position: absolute;
			top: 50%;
			left: 50%;
			transition: translate(-50%, -50%);
			
			.dot {
				width: 7px;
				height: 7px;
				background-color: white;
				border-radius: 50%;
				float: left;
				margin: 0 5px;
				-webkit-transform: scale(0);
				transform: scale(0);
				-webkit-animation: fx 1000ms ease infinite 0ms;
						animation: fx 1000ms ease infinite 0ms;
						
				&:nth-child(2) {
					-webkit-animation: fx 1000ms ease infinite 300ms;
							animation: fx 1000ms ease infinite 300ms;
				}
				&:nth-child(3) {
					-webkit-animation: fx 1000ms ease infinite 600ms;
							animation: fx 1000ms ease infinite 600ms;
				}
			}
		}
	}
	
	@-webkit-keyframes fx { 50% { -webkit-transform: scale(1); transform: scale(1); opacity: 1; } 100% { opacity: 0; } }
	@keyframes fx { 50% {  -webkit-transform: scale(1); transform: scale(1); opacity: 1; } 100% { opacity: 0; } }

	/* FOOTER */
	
	footer{
		position: fixed;
		bottom: 0;
		width: 100%;
		background-color: black;
		padding: 7px 0;
		
		.feedback{
			cursor: pointer;
		}
		
		.links{
			a{
				text-decoration: none;
				color: white;
				margin-left: 10px;
				padding-left: 10px;
				border-left: 1px solid white;
				
				&:first-child{
					border-left: none;
				}
			}
		}
	}

	
	/* RULES */
	
	
	.vairus-details{
		position: fixed;
		top: 0;
		left: 0;
		bottom: 0;
		right: 0;
		z-index: 5;
		
		.backdrop{
			position: absolute;
			top: 0;
			left: 0;
			bottom: 0;
			right: 0;
			background-color: rgba(0,0,0,0.7);
		}
	}
	
	.tooltip{
		position: fixed;
		padding: 10px;
		background-color: #11070F;
		z-index: 5;
		max-width: 500px;
	}

	
	/* GLITCH ANIMATION */

	.glitch{
		position: relative;
	}
	.glitch::before {
		content: attr(data-text);
		position: absolute;
		top: 0;
		left: 0;
		width: 100%;
		height: 100%;
		left: 2px;
		clip: rect(0, 0, 0, 0);
		text-shadow: -2px 0 #ff00c1;
		animation: glitch-anim 5s infinite linear alternate-reverse;
		padding-right: 20px;
		padding-top: 10px;
	}


	@keyframes glitch-anim {
	  0% {
		clip: rect(47px, 9999px, 21px, 0);
		transform: skew(0.21deg);
	  }
	  1% {
		clip: rect(23px, 9999px, 77px, 0);
		transform: skew(0.9deg);
	  }
	  2% {
		clip: rect(56px, 9999px, 84px, 0);
		transform: skew(0.34deg);
	  }
	  3% {
		clip: rect(88px, 9999px, 14px, 0);
		transform: skew(0.29deg);
	  }
	  4% {
		clip: rect(31px, 9999px, 51px, 0);
		transform: skew(0.75deg);
	  }
	  5% {
		clip: rect(41px, 9999px, 48px, 0);
		transform: skew(0.41deg);
	  }
	  6% {
		clip: rect(24px, 9999px, 55px, 0);
		transform: skew(0.37deg);
	  }
	  7% {
		clip: rect(14px, 9999px, 13px, 0);
		transform: skew(0.94deg);
	  }
	  8% {
		clip: rect(0, 0, 0, 0);
		transform: none;
	  }
	  32% {
		clip: rect(0, 0, 0, 0);
		transform: none;
	  }
	  33% {
		clip: rect(69px, 9999px, 10px, 0);
		transform: skew(0.74deg);
	  }
	  34% {
		clip: rect(63px, 9999px, 95px, 0);
		transform: skew(0.45deg);
	  }
	  35% {
		clip: rect(34px, 9999px, 4px, 0);
		transform: skew(0.28deg);
	  }
	  36% {
		clip: rect(44px, 9999px, 10px, 0);
		transform: skew(0.22deg);
	  }
	  37% {
		clip: rect(96px, 9999px, 99px, 0);
		transform: skew(0.47deg);
	  }
	  38% {
		clip: rect(67px, 9999px, 42px, 0);
		transform: skew(0.1deg);
	  }
	  39% {
		clip: rect(8px, 9999px, 85px, 0);
		transform: skew(0.4deg);
	  }
	  40% {
		clip: rect(44px, 9999px, 32px, 0);
		transform: skew(0.64deg);
	  }
	  41% {
		clip: rect(0, 0, 0, 0);
		transform: none;
	  }
	  65% {
		clip: rect(0, 0, 0, 0);
		transform: none;
	  }
	  66% {
		clip: rect(61px, 9999px, 67px, 0);
		transform: skew(0.08deg);
	  }
	  67% {
		clip: rect(10px, 9999px, 72px, 0);
		transform: skew(0.34deg);
	  }
	  68% {
		clip: rect(57px, 9999px, 59px, 0);
		transform: skew(0.03deg);
	  }
	  69% {
		clip: rect(39px, 9999px, 87px, 0);
		transform: skew(0.91deg);
	  }
	  70% {
		clip: rect(26px, 9999px, 40px, 0);
		transform: skew(0.93deg);
	  }
	  71% {
		clip: rect(0, 0, 0, 0);
		transform: none;
	  }
	}

	/* PULSE ANIMATION */
	
	
	@keyframes pulse {
		0% {
			transform: scale(1);
		}
		50% {
			transform: scale(1.2);
		}
		100% {
			transform: scale(1);
		}
	}



	
	@media screen and (max-width: 800px) {
		.main-header{
		    padding-bottom: 50px;

			.glitch-wrapper h3{
				font-size: 4rem;
			}
			.panel-index{
			    position: absolute;
				left: 0;
				width: 100%;
				top: 135px;
			}
		}
	}
	@media screen and (max-width: 480px) {
		.main-header{
			.panel-index{
				font-size: 1rem;
				
				ul li{
					padding: 0 10px;
				}
				svg{
				    width: 20px;
					height: 20px;
			   }
			}
		}
		
		footer.small-font{
			font-size: 0.65rem;
		}
		
		.bag-modal .inner{
			width: 95vw;
			
			.shards .flex .item, 
			.keys .flex .item{
				flex: 1 0 42%;
			}
		}
	}
</style>